package com.coti.tools;
import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.io.*;
import javax.swing.filechooser.FileFilter;

/**
@author Coti 2006
	@version 1.5
 */
public class AuxFile {
	
	public static File getFileForOpening(Component owner) {
		File f = null;
		JFileChooser selector = new JFileChooser(System.getProperty("user.dir"));
		
		if(selector.showOpenDialog(owner)==JFileChooser.APPROVE_OPTION)
			f = selector.getSelectedFile();
		else
	    f = null;
		
		return f;
	}
	
	public static File getFileForSaving(Component owner) {
		File f = null;
		JFileChooser selector = new JFileChooser(System.getProperty("user.dir"));
		
		if(selector.showSaveDialog(owner)==JFileChooser.APPROVE_OPTION)
			f = selector.getSelectedFile();
		else
	    	f = null;
		
		return f;
	}
	public static File getFilteredFileForOpening(	Component owner, 
																								FileFilter filter) {
		File f = null;
		JFileChooser selector = new JFileChooser(System.getProperty("user.dir"));
		selector.setFileFilter(filter);
		if(selector.showOpenDialog(owner)==JFileChooser.APPROVE_OPTION)
			f = selector.getSelectedFile();
		else
	    	f = null;
		
		return f;
	}
	
	public static File getFilteredFileForSaving(	Component owner,
																								FileFilter filter) {
		File f = null;
		JFileChooser selector = new JFileChooser(System.getProperty("user.dir"));
		selector.setFileFilter(filter);
		if(selector.showSaveDialog(owner)==JFileChooser.APPROVE_OPTION)
			f = selector.getSelectedFile();
		else
	    	f = null;
		
		return f;
	}
	
	public static String[] readAllLines(File f){
		String[] tempList = null;
		ArrayList<String> al = new ArrayList<String>();
		Scanner s = null;
		try
		{
			s = new Scanner(f);
		}
		catch(Exception e)
		{
			System.err.println("\nSorry, file not found.");
			return null;
		}
		while(s.hasNext())
			al.add(s.nextLine());
		s.close();
		al.trimToSize();
		tempList = new String[al.size()];     
		al.toArray(tempList);
		return tempList;
	}
	
	public static String[][] readDelimitedAsTable(File f, String delimiter){
		String[] tempList = readAllLines(f);
		int numberOfRows = tempList.length;
		int numberOfColumns = 1; //tempList[0].split(delimiter).length;
		String[][] tempTable = new String[numberOfRows][numberOfColumns];
		for(int i=0;i<numberOfRows;i++)
			tempTable[i] = tempList[i].split(delimiter);
		return tempTable;
/*
		Note.- numberOfColumns can be set to one when declaring
		tempTable, and this will minimize memory consumption. One must bear
		in mind that a String[][] is a list of String[]. Hence the tempTable
		assignment is replacing a pointer to a String[] (the one created on
		declaration) with another (the one created by calling split). The
		first String[] is never used and recycled. Hence it can be just a
		place holder initially.
		
		Note.- There is, however, a possible use for
		numberOfColumns. One could tell the user if any row happens to have
		too few or too many fields (a number of fields different from
		numberOfColumns). This would be a safety measure, and would help the
		user to detect possible flaws in the input. No provision is made for
		empty lines. They will pass throug and create a set of empty fields.
		This should be detected and corrected, possibly discarding any such
		rows. In that case a second one would possibly be better of by means
		of an early detection (before splitting), just adding valid rows.
		This is really a matter of taste and/or need, although it is agreed
		that something should be done (poss. by the receiver of the
		results). It is easy to find empty rows, since result[i].length (the
		number of columnis in i-th row) will be zero.
*/
	}
	
	public static void writeAllLines(String text, File f) {
		FileWriter fw;
		try
		{
			fw = new FileWriter(f);
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(null,
																		e.toString(),
																		"Error while opening for writing",
																		JOptionPane.ERROR_MESSAGE);
			return;
		}
		BufferedWriter bw = new BufferedWriter(fw);
		try
		{
			bw.write(text,0,text.length());
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog( null,
																		 e.toString(),
																		 "Error while writing",
																		 JOptionPane.ERROR_MESSAGE);
		}
		try
		{
			bw.close();
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(	null,
																			e.toString(),
																			"Error while closing after writing",
																			JOptionPane.ERROR_MESSAGE);
		}
	}	
}