package com.coti.tools;

import javax.swing.*;
import java.awt.*;

public class JFrameAI extends JFrame {
    public static final int CENTER   = 0;
    public static final int PLATFORM = 1;
    public static final int NONE     = 2;
    private double scale = 4.0/5.0;
    private int placement = 1;
    public JFrameAI(String title, int placement) {
        super(title);
        this.placement = placement;
        prepare();
    }
    public JFrameAI(	String title,
            int placement,
            double scale) {
        super(title);
        this.placement = placement;
        this.scale = scale;
        prepare();
    }
    private void errMess(String message, String title) {
        JOptionPane.showMessageDialog(	this,
                message,
                title,
                JOptionPane.ERROR_MESSAGE);
    }
    public static void errMess(	Component owner,
            String message,
            String title) {
        JOptionPane.showMessageDialog(	owner,
                message,
                title,
                JOptionPane.ERROR_MESSAGE);
        return;
    }

    public static void pws(	SpringLayout d,
            Component comp,
            int xPos,
            int yPos,
            int width,
            int height) {
        Dimension dim = new Dimension(width, height);
        comp.setPreferredSize(dim);
        comp.setMaximumSize(dim);
        
        SpringLayout.Constraints cons = d.getConstraints(comp);
        cons.setX(Spring.constant(xPos));
        cons.setY(Spring.constant(yPos));
    }

    private void prepare() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        Dimension scSz = Toolkit.getDefaultToolkit().getScreenSize();
        double newWidth = scSz.getWidth() * scale;
        double newHeight = scSz.getHeight() * scale;
        Dimension newDimension = new Dimension();
        newDimension.setSize(newWidth, newHeight);
        if (0.0 != scale)
            setSize(newDimension);
        if (CENTER == placement)
            setLocationRelativeTo(null);
        else if (PLATFORM == placement)
            setLocationByPlatform(true);
        else if (NONE == placement)
            ; // Do nothing;
        this.setResizable(false);
    }
}
